Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/test/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilderTest.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/test/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilderTest.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/test/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilderTest.java	(revision 44198)
@@ -0,0 +1,507 @@
+package org.gvsig.fmap.dal.store.h2;
+
+import junit.framework.TestCase;
+import org.apache.commons.lang3.ArrayUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.fmap.crs.CRSFactory;
+import org.gvsig.fmap.dal.SQLBuilder;
+import org.gvsig.fmap.dal.SQLBuilder.Privilege;
+import org.gvsig.fmap.dal.feature.spi.SQLBuilderBase;
+import org.gvsig.fmap.geom.DataTypes;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.primitive.Polygon;
+import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
+
+public class H2SpatialSQLBuilderTest extends TestCase {
+    
+    public H2SpatialSQLBuilderTest(String testName) {
+        super(testName);
+    }
+
+    @Override
+    protected void setUp() throws Exception {
+        super.setUp();
+        new DefaultLibrariesInitializer().fullInitialize();
+    }
+
+    @Override
+    protected void tearDown() throws Exception {
+        super.tearDown();
+    }
+
+    private SQLBuilder createSQLBuilder() {
+        return new H2SpatialSQLBuilder(new H2SpatialHelper(null));
+    }
+    
+ 
+    public void testCalulateEnvelope() throws Exception {
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Polygon limit = geometryManager.createPolygon(Geometry.SUBTYPES.GEOM2D);
+        limit.addVertex(0, 0);
+        limit.addVertex(0, 100);
+        limit.addVertex(100, 100);
+        limit.addVertex(100, 0);
+        limit.addVertex(0, 0);
+        
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
+        sqlbuilder.select().column().value(
+            expbuilder.as_geometry(
+              expbuilder.ST_ExtentAggregate(
+                expbuilder.column("the_geom")
+              )
+            )
+        ).as("envelope");
+        sqlbuilder.select().from().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.select().where().set(
+            expbuilder.ST_Intersects(
+                expbuilder.ST_Envelope(
+                    expbuilder.column("the_geom")
+                ),
+                expbuilder.geometry(limit, proj)
+            )
+        );
+        sqlbuilder.select().where().and(
+                expbuilder.custom("x = 27")
+        );
+        
+        System.out.println("# Test:: testCalulateEnvelope");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "SELECT ST_AsBinary(ST_ExtentAggregate(\"the_geom\")) AS \"envelope\" FROM \"test1\" WHERE ( ((ST_Envelope(\"the_geom\")) && (ST_GeomFromWKB((DECODE('000000000300000001000000050000000000000000000000000000000000000000000000004059000000000000405900000000000040590000000000004059000000000000000000000000000000000000000000000000000000000000','hex')), (4326)))) AND ST_Intersects((ST_Envelope(\"the_geom\")),(ST_GeomFromWKB((DECODE('000000000300000001000000050000000000000000000000000000000000000000000000004059000000000000405900000000000040590000000000004059000000000000000000000000000000000000000000000000000000000000','hex')), (4326))) )) AND x = 27",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[the_geom]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testCount() throws Exception {
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
+        sqlbuilder.select().column().value(sqlbuilder.count().all());
+        sqlbuilder.select().from().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.select().from().subquery(null);
+        sqlbuilder.select().where().set( expbuilder.custom("pp = 200"));
+
+        System.out.println("# Test:: testCount");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+
+        //# Test:: testCount
+        //# SQL:: SELECT COUNT(*) FROM "test1" WHERE pp = 200
+        //# Variables:: []
+        //# Parametros:: []
+
+        assertEquals(
+                "SELECT COUNT(*) FROM \"test1\" WHERE pp = 200",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+    
+    public void testCreateTable() throws Exception {
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.create_table().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.create_table().add_column(
+                "name",
+                DataTypes.STRING,
+                45,
+                0,
+                false,
+                false,
+                true,
+                false,
+                null
+        );
+        sqlbuilder.create_table().add_column(
+                "id",
+                DataTypes.INT,
+                0,
+                0,
+                true,
+                false,
+                false,
+                true,
+                0
+        );
+        sqlbuilder.create_table().add_column(
+                "geom",
+                DataTypes.GEOMETRY,
+                0,
+                0,
+                false,
+                false,
+                true,
+                false,
+                null
+        );
+
+        
+        // CREATE TABLE "test1" ("name" VARCHAR(45) DEFAULT NULL, "id" INTEGER PRIMARY KEY AUTO_INCREMENT DEFAULT '0' NOT NULL, "geom" GEOMETRY ); ALTER TABLE "test1" ADD CONSTRAINT IF NOT EXISTS "constraint_test1_geom_dim" CHECK ST_CoordDim("geom") = 2
+        System.out.println("# Test:: testCreateTable");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "CREATE TABLE \"test1\" (\"name\" VARCHAR(45) DEFAULT NULL, \"id\" INTEGER PRIMARY KEY AUTO_INCREMENT DEFAULT '0' NOT NULL, \"geom\" GEOMETRY ); ALTER TABLE \"test1\" ADD CONSTRAINT IF NOT EXISTS \"constraint_test1_geom_dim\" CHECK ST_CoordDim(\"geom\") = 2",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testDropTable() throws Exception {
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
+        sqlbuilder.drop_table().table().database("master").schema("dbo").name("test1");
+
+        // DROP TABLE "test1"
+        
+        System.out.println("# Test:: testDropTable");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "DROP TABLE \"test1\"",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+    
+    public void testFetchFeatureProviderByReference() throws Exception {
+        SQLBuilder sqlbuilder = new SQLBuilderBase();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
+        String value = "yoyo";
+        sqlbuilder.select().column().name("name");
+        sqlbuilder.select().column().name("id");
+        sqlbuilder.select().column().name("geom").as_geometry();
+        sqlbuilder.select().from().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.select().where().set(
+            expbuilder.eq(
+                expbuilder.column("name"),
+                expbuilder.parameter(value).as_constant()
+            )
+        );
+        sqlbuilder.select().limit(1);
+
+        // SELECT "name", "id", ST_AsBinary("geom") FROM "master"."dbo"."test1" WHERE ( ("name") = (?) ) LIMIT 1
+
+        System.out.println("# Test:: testFetchFeatureProviderByReference");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "SELECT \"name\", \"id\", ST_AsBinary(\"geom\") FROM \"master\".\"dbo\".\"test1\" WHERE ( (\"name\") = (?) ) LIMIT 1",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "['yoyo']",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+    
+    public void testFetchFeatureType() throws Exception {
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.select().column().all();
+        sqlbuilder.select().from().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.select().limit(1);
+
+        System.out.println("# Test:: testFetchFeatureType");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        
+        //# Test:: testFetchFeatureType
+        //# SQL:: SELECT * FROM "test1" LIMIT 1
+        //# Variables:: []
+        //# Parametros:: []        
+        
+        assertEquals(
+                "SELECT * FROM \"test1\" LIMIT 1",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+        
+    public void testPerformDeletes() throws Exception {
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.delete().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.delete().where().and(
+            expbuilder.eq( 
+                expbuilder.column("id1"),
+                expbuilder.parameter("id1").as_variable()
+            )
+        );
+        sqlbuilder.delete().where().and(
+            expbuilder.eq( 
+                expbuilder.column("id2"),
+                expbuilder.parameter("id2").as_variable()
+            )
+        );
+
+        // DELETE FROM "test1" WHERE ( ("id1") = (?) ) AND ( ("id2") = (?) )
+
+        System.out.println("# Test:: testPerformDeletes");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "DELETE FROM \"test1\" WHERE ( (\"id1\") = (?) ) AND ( (\"id2\") = (?) )",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[id1, id2]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[\"id1\", \"id2\"]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testPerformInserts1() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.insert().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.insert().column().name("id").with_value(expbuilder.parameter("id"));
+        sqlbuilder.insert().column().name("name").with_value(expbuilder.parameter("name"));
+        sqlbuilder.insert().column().name("geom").with_value(expbuilder.parameter("geom").as_geometry_variable().srs(proj));
+        
+        System.out.println("# Test:: testPerformInserts1");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "INSERT INTO \"test1\" ( \"id\", \"name\", \"geom\" ) VALUES ( ?, ?, ST_GeomFromWKB((?), (4326)) )",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[\"id\", \"name\", \"geom\"]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testPerformInserts2() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.insert().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.insert().column().name("id").with_value(expbuilder.parameter("id"));
+        sqlbuilder.insert().column().name("name").with_value(expbuilder.parameter("name"));
+        sqlbuilder.insert().column().name("geom").with_value(expbuilder.parameter("geom").as_geometry_variable().srs(proj));
+        
+        System.out.println("# Test:: testPerformInserts2");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "INSERT INTO \"test1\" ( \"id\", \"name\", \"geom\" ) VALUES ( ?, ?, ST_GeomFromWKB((?), (4326)) )",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[\"id\", \"name\", \"geom\"]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testPerformUpdates1() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.update().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.update().where().and(
+            expbuilder.eq(
+                expbuilder.column("id"), 
+                expbuilder.parameter("id").as_variable()
+            )
+        );
+        sqlbuilder.update().column().name("name").with_value(expbuilder.parameter("name"));
+        sqlbuilder.update().column().name("geom").with_value(
+                expbuilder.parameter("geom").as_geometry_variable().srs(proj) 
+        );
+
+        System.out.println("# Test:: testPerformUpdates");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "UPDATE \"test1\" SET \"name\" = ?, \"geom\" = ST_GeomFromWKB((?), (4326)) WHERE ( (\"id\") = (?) )",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[\"name\", \"geom\", \"id\"]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testPerformUpdates2() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.update().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.update().where().and(
+            expbuilder.eq(
+                expbuilder.column("id"), 
+                expbuilder.parameter("id").as_variable()
+            )
+        );
+        sqlbuilder.update().column().name("name").with_value(expbuilder.parameter("name"));
+        sqlbuilder.update().column().name("geom").with_value(
+                expbuilder.parameter("geom").as_geometry_variable()
+                        .srs(expbuilder.parameter().value(proj)) 
+        );
+
+        System.out.println("# Test:: testPerformUpdates");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "UPDATE \"test1\" SET \"name\" = ?, \"geom\" = ST_GeomFromWKB((?), (?)) WHERE ( (\"id\") = (?) )",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[\"name\", \"geom\", 4326, \"id\"]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testGrant1() throws Exception {
+
+        SQLBuilder sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.grant().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.grant().role("prueba").select().insert().update();
+        sqlbuilder.grant().role("gis").all();
+                
+        
+        System.out.println("# Test:: testGrant1");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+    public void testGrant2() throws Exception {
+
+        SQLBuilder sqlbuilder = new SQLBuilderBase();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
+        sqlbuilder.grant().table().database("master").schema("dbo").name("test1");
+        sqlbuilder.grant().role("prueba").privilege(Privilege.SELECT)
+                .privilege(Privilege.INSERT)
+                .privilege(Privilege.UPDATE);
+        sqlbuilder.grant().role("gis").privilege(Privilege.ALL);
+                
+        
+        System.out.println("# Test:: testGrant2");
+        System.out.println("# SQL:: " + sqlbuilder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(sqlbuilder.variables_names()));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(sqlbuilder.parameters_names()));
+        assertEquals(
+                "",
+                sqlbuilder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.variables_names())
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(sqlbuilder.parameters_names())
+        );
+    }
+
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNull.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNull.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNull.java	(revision 44198)
@@ -0,0 +1,49 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.Code.Constant;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+class IsNull implements Formatter<Value> {
+
+    private final Formatter<Value> formatter;
+    private final SQLBuilder builder;
+    
+    public IsNull(SQLBuilder builder, Formatter<Value> formatter) {
+        this.builder = builder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(Value value) {
+        if (value instanceof Function) {
+            if( StringUtils.equalsIgnoreCase(OPERATOR_IS, ((Function) value).name()) ) {
+                List<Value> parameters = ((Function) value).parameters();
+                Value p2 = parameters.get(1);
+                if( p2 instanceof Constant && ((Constant)p2).value()==null ) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value function) {
+        List<Value> parameters = ((Function) function).parameters();
+        String p1 = parameters.get(0).toString(formatter);
+        String r = MessageFormat.format("( ({0}) IS NULL )", p1);
+        return r;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNotNull.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNotNull.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IsNotNull.java	(revision 44198)
@@ -0,0 +1,62 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.Code.Constant;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NOT;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+class IsNotNull implements Formatter<Value> {
+
+    private final Formatter<Value> formatter;
+    private final SQLBuilder builder;
+    
+    public IsNotNull(SQLBuilder builder, Formatter<Value> formatter) {
+        this.builder = builder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(Value value_not) {
+        if (value_not instanceof Function) {
+            // NOT( IS( p1, NULL) )
+            if( StringUtils.equalsIgnoreCase(OPERATOR_NOT, ((Function) value_not).name()) ) {
+                List<Value> parameters = ((Function) value_not).parameters();
+                Value value_is = parameters.get(0);
+                if( value_is instanceof Function && StringUtils.equalsIgnoreCase(OPERATOR_IS, ((Function)value_is).name()) ) {
+                    List<Value> parameters_is = ((Function)value_is).parameters();
+                    Value is_p2 = parameters_is.get(1);
+                    if( is_p2 instanceof Constant && ((Constant)is_p2).value()==null ) {
+                        return true;
+                    }
+                }
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value value_not) {
+        // NOT( IS( p1, NULL) )
+
+        List<Value> parameters = ((Function) value_not).parameters();
+        Value value_is = parameters.get(0);
+        List<Value> parameters_is = ((Function)value_is).parameters();
+        Value is_p1 = parameters_is.get(0);
+        String r = MessageFormat.format(
+                "( ({0}) IS NOT NULL )", 
+                is_p1.toString(formatter)
+        );
+        return r;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IfNull.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IfNull.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/IfNull.java	(revision 44198)
@@ -0,0 +1,54 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.Code.Constant;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_IFNULL;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+class IfNull implements Formatter<Value> {
+
+    private final Formatter<Value> formatter;
+    private final SQLBuilder builder;
+    
+    public IfNull(SQLBuilder builder, Formatter<Value> formatter) {
+        this.builder = builder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(Value value) {
+        if (value instanceof Function) {
+            if (value instanceof ExpressionBuilder.Function) {
+                return StringUtils.equalsIgnoreCase(FUNCTION_IFNULL, ((Function) value).name());
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value function) {
+            List<Value> parameters = ((Function) function).parameters();
+            String p1 = parameters.get(0).toString(formatter);
+            String p2 = parameters.get(1).toString(formatter);
+            String p3 = parameters.get(2).toString(formatter);
+            String r = MessageFormat.format(
+                    "NVL2({0}, {1}, {2})",
+                    p1,
+                    p3,
+                    p2
+            );
+            return r;
+    }
+    
+}
